#define tween_init
//tween_init();
//initiates the tween engine

globalvar OBJ_TWEEN;
OBJ_TWEEN = object_add();
object_set_sprite(OBJ_TWEEN,-1);
object_set_solid(OBJ_TWEEN,0);
object_set_visible(OBJ_TWEEN,0);
object_set_persistent(OBJ_TWEEN,0);
object_set_mask(OBJ_TWEEN,-1);
object_set_parent(OBJ_TWEEN,-1);
object_set_depth(OBJ_TWEEN,10000000);

object_event_add(OBJ_TWEEN,ev_step,ev_step_normal,
 "
  switch tweenType_nm {
   case TWEENTYPE_REG:
    with (inst_id) {
     variable_local_set(other.variable_str,other.incrementStart_nm+(other.incrementStop_nm-other.incrementStart_nm)*tween_easing(other.easing_str,(other.incrementTime_nm-other.alarm[0])/other.incrementTime_nm));
    }
   break;
   case TWEENTYPE_COLOR:
    with (inst_id) {
     variable_local_set(other.variable_str,merge_color(other.incrementStart_nm,other.incrementStop_nm,tween_easing(other.easing_str,(other.incrementTime_nm-other.alarm[0])/other.incrementTime_nm)));
    }
   break;
  }
 "
);
object_event_add(OBJ_TWEEN,ev_alarm,0,
 "
  switch tweenRepeat_nm {
   case TWEENREPEAT_NONE:
    with (inst_id) {
     variable_local_set(other.variable_str,other.incrementStop_nm);
    }
    instance_destroy();
   break;
   case TWEENREPEAT_LOOP:
    var i;
    i = incrementStart_nm;
    incrementStart_nm = incrementStop_nm;
    incrementStop_nm = i;
    alarm[0] = incrementTime_nm-1;
   break;
   case TWEENREPEAT_PULSE:
    alarm[0] = incrementTime_nm-1;
   break;
  }
 "
);

#define tween
//tween(id, variable, start, stop, time);
//tweens variable (given as a string) from start to stop in time amount time

//create the object that will run through the tween
var inst;
inst = instance_create(0,0,OBJ_TWEEN);
inst.tweenType_nm = TWEENTYPE_REG;
inst.tweenRepeat_nm = TWEENREPEAT_NONE;
inst.easing_str = TWEENEASE_REG;
inst.inst_id = argument0;
inst.variable_str = argument1;
inst.incrementStart_nm = argument2;
inst.incrementStop_nm = argument3;
inst.incrementTime_nm = argument4;
inst.alarm[0] = argument4;
with (argument0) {
 variable_local_set(other.argument1,other.argument2);
}

return inst;

#define tween_color
//tween_color(id, variable, start, stop, time);
//tweens the color variable (given as a string) from start to stop in time amount time

//create the object that will run through the tween
var inst;
inst = instance_create(0,0,OBJ_TWEEN);
inst.tweenType_nm = TWEENTYPE_COLOR;
inst.tweenRepeat_nm = TWEENREPEAT_NONE;
inst.easing_str = TWEENEASE_REG;
inst.inst_id = argument0;
inst.variable_str = argument1;
inst.incrementStart_nm = argument2;
inst.incrementStop_nm = argument3;
inst.incrementTime_nm = argument4;
inst.alarm[0] = argument4;

return inst;

#define tween_gen
//tween_gen(id, variable, start, stop, time, type, repeat, easing)
//tweens the variable given as a string from start to stop over frame interval
//time, of the given type, with repeat and easing properties indicated.  type
//and repeat default to 0 (TWEENTYPE_REG, and TWEENREPEAT_NONE)

//create the object that will run through the tween
var inst;
inst = instance_create(0,0,OBJ_TWEEN);
inst.tweenType_nm = argument5;
inst.tweenRepeat_nm = argument6;
inst.inst_id = argument0;
inst.variable_str = argument1;
if is_string(argument7) {
 inst.easing_str = argument7;
} else {
 inst.easing_str = TWEENEASE_REG;
}
inst.incrementStart_nm = argument2;
inst.incrementStop_nm = argument3;
inst.incrementTime_nm = argument4;
inst.alarm[0] = argument4;
with (argument0) {
 variable_local_set(other.argument1,other.argument2);
}

return inst;

#define tween_easing
//tween_easing(easing_str, value)
//returns the percentage through the variable change that should accompany value percentate of time through

var X_;
X_ = argument1;
var tmp;
switch argument0 {
 case TWEENEASE_SIN_UP:
  tmp = sin(X_*(pi/2));
 break;
 case TWEENEASE_SIN_DOWN:
  tmp = sin((X_*(pi/2))+(pi/2));
 break;
 case  TWEENEASE_COS_UP:
  tmp = 1-sin(X_*(pi/2));
 break;
 case TWEENEASE_COS_DOWN:
  tmp = 1-sin((X_*(pi/2))+(pi/2));
 break;
 case TWEENEASE_LOG:
  tmp = 1/(1+exp(-10*X_+5));
 break;
 case TWEENEASE_LOG_INV:
  tmp = (ln((1/X_)-1)-5)/-10;
 break;
 case TWEENEASE_REG:
  tmp = X_;
 break;
 default:
  tmp = X_;
 break;
}

return tmp;